



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Spring bean configuration inheritance</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Spring bean configuration inheritance</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-07 03:59:54 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>In Spring, the inheritance is supported in bean configuration for a bean to share common values, properties or configurations.<br /><br />
A child bean or inherited bean can inherit its parent bean configurations, properties and some attributes. In additional, the child beans are allow to override the inherited value.<br /><br />
See following full example to show you how bean configuration inheritance works in Spring.</p>
<pre class="prettyprint linenums"><code>package com.mkyong.common;

public class Customer {

	private int type;<br />
	private String action;<br />
	private String Country;

	//...

}<br />
</code></pre>
<p>Bean configuration file</p>
<pre class="prettyprint linenums"><code>&lt;beans xmlns=&quot;http://www.springframework.org/schema/beans&quot;<br />
	xmlns:xsi=&quot;http://www.w3.org/2001/XMLSchema-instance&quot;<br />
	xsi:schemaLocation=&quot;http://www.springframework.org/schema/beans<br />
	http://www.springframework.org/schema/beans/spring-beans-2.5.xsd&quot;&gt;

	&lt;bean id=&quot;BaseCustomerMalaysia&quot; class=&quot;com.mkyong.common.Customer&quot;&gt;<br />
		&lt;property name=&quot;country&quot; value=&quot;Malaysia&quot; /&gt;<br />
	&lt;/bean&gt;

	&lt;bean id=&quot;CustomerBean&quot; parent=&quot;BaseCustomerMalaysia&quot;&gt;<br />
		&lt;property name=&quot;action&quot; value=&quot;buy&quot; /&gt;<br />
		&lt;property name=&quot;type&quot; value=&quot;1&quot; /&gt;<br />
	&lt;/bean&gt;

&lt;/beans&gt;<br />
</code></pre>
<p>Above is a ‘<code>BaseCustomerMalaysia</code>’ bean contains a ‘<code>Malaysia</code>’ value for <code>country</code> property, and the ‘<code>CustomerBean</code>’ bean inherited this value from its parent (‘<code>BaseCustomerMalaysia</code>’).</p>
<p>Run it</p>
<pre class="prettyprint linenums"><code>package com.mkyong.common;

import org.springframework.context.ApplicationContext;<br />
import org.springframework.context.support.ClassPathXmlApplicationContext;

public class App<br />
{<br />
    public static void main( String[] args )<br />
    {<br />
    	ApplicationContext context =<br />
			new ClassPathXmlApplicationContext(&quot;SpringBeans.xml&quot;);

    	Customer cust = (Customer)context.getBean(&quot;CustomerBean&quot;);<br />
    	System.out.println(cust);

    }<br />
}<br />
</code></pre>
<p>output</p>
<pre class="prettyprint linenums"><code>Customer [type=1, action=buy, Country=Malaysia]<br />
</code></pre>
<p>The ‘<code>CustomerBean</code>’ bean just inherited the <code>country</code> property from its parent (‘<code>BaseCustomerMalaysia</code>’).</p>
<h2>Inheritance with abstract</h2>
<p>In above example, the ‘<code>BaseCustomerMalaysia</code>’ is still able to instantiate, for example,</p>
<pre class="prettyprint linenums"><code>	Customer cust = (Customer)context.getBean(&quot;BaseCustomerMalaysia&quot;);<br />
</code></pre>
<p>If you want to make this base bean as a template and not allow others to instantiate it, you can add an ‘<code>abstract</code>‘ attribute in the <code>&lt;bean&gt;</code> element. For example</p>
<pre class="prettyprint linenums"><code>&lt;beans xmlns=&quot;http://www.springframework.org/schema/beans&quot;<br />
	xmlns:xsi=&quot;http://www.w3.org/2001/XMLSchema-instance&quot;<br />
	xsi:schemaLocation=&quot;http://www.springframework.org/schema/beans<br />
	http://www.springframework.org/schema/beans/spring-beans-2.5.xsd&quot;&gt;

	&lt;bean id=&quot;BaseCustomerMalaysia&quot; class=&quot;com.mkyong.common.Customer&quot; abstract=&quot;true&quot;&gt;<br />
		&lt;property name=&quot;country&quot; value=&quot;Malaysia&quot; /&gt;<br />
	&lt;/bean&gt;

	&lt;bean id=&quot;CustomerBean&quot; parent=&quot;BaseCustomerMalaysia&quot;&gt;<br />
		&lt;property name=&quot;action&quot; value=&quot;buy&quot; /&gt;<br />
		&lt;property name=&quot;type&quot; value=&quot;1&quot; /&gt;<br />
	&lt;/bean&gt;

&lt;/beans&gt;<br />
</code></pre>
<p>Now, the ‘<code>BaseCustomerMalaysia</code>’ bean is a pure template, for bean to inherit it only, if you try to instantiate it, you will encounter the following error message.</p>
<pre class="prettyprint linenums"><code>	Customer cust = (Customer)context.getBean(&quot;BaseCustomerMalaysia&quot;);

org.springframework.beans.factory.BeanIsAbstractException:<br />
	Error creating bean with name 'BaseCustomerMalaysia':<br />
	Bean definition is abstract

</code></pre>
<h2>Pure Inheritance Template</h2>
<p>Actually, parent bean is not necessary to define <code>class</code> attribute, often times, you may just need a common property for sharing. Here’s is an example</p>
<pre class="prettyprint linenums"><code>&lt;beans xmlns=&quot;http://www.springframework.org/schema/beans&quot;<br />
	xmlns:xsi=&quot;http://www.w3.org/2001/XMLSchema-instance&quot;<br />
	xsi:schemaLocation=&quot;http://www.springframework.org/schema/beans<br />
	http://www.springframework.org/schema/beans/spring-beans-2.5.xsd&quot;&gt;

	&lt;bean id=&quot;BaseCustomerMalaysia&quot; abstract=&quot;true&quot;&gt;<br />
		&lt;property name=&quot;country&quot; value=&quot;Malaysia&quot; /&gt;<br />
	&lt;/bean&gt;

	&lt;bean id=&quot;CustomerBean&quot; parent=&quot;BaseCustomerMalaysia&quot;<br />
	    class=&quot;com.mkyong.common.Customer&quot;&gt;

		&lt;property name=&quot;action&quot; value=&quot;buy&quot; /&gt;<br />
		&lt;property name=&quot;type&quot; value=&quot;1&quot; /&gt;<br />
	&lt;/bean&gt;

&lt;/beans&gt;<br />
</code></pre>
<p>In this case, the ‘<code>BaseCustomerMalaysia</code>’ bean is a pure template, to share its ‘<code>country</code>’ property only.</p>
<h2>Overrride it</h2>
<p>However, you are still allow to override the inherited value by specify the new value in the child bean. Let’s see this example</p>
<pre class="prettyprint linenums"><code>&lt;beans xmlns=&quot;http://www.springframework.org/schema/beans&quot;<br />
	xmlns:xsi=&quot;http://www.w3.org/2001/XMLSchema-instance&quot;<br />
	xsi:schemaLocation=&quot;http://www.springframework.org/schema/beans<br />
	http://www.springframework.org/schema/beans/spring-beans-2.5.xsd&quot;&gt;

	&lt;bean id=&quot;BaseCustomerMalaysia&quot; class=&quot;com.mkyong.common.Customer&quot; abstract=&quot;true&quot;&gt;<br />
		&lt;property name=&quot;country&quot; value=&quot;Malaysia&quot; /&gt;<br />
	&lt;/bean&gt;

	&lt;bean id=&quot;CustomerBean&quot; parent=&quot;BaseCustomerMalaysia&quot;&gt;<br />
	    &lt;property name=&quot;country&quot; value=&quot;Japan&quot; /&gt;<br />
		&lt;property name=&quot;action&quot; value=&quot;buy&quot; /&gt;<br />
		&lt;property name=&quot;type&quot; value=&quot;1&quot; /&gt;<br />
	&lt;/bean&gt;

&lt;/beans&gt;<br />
</code></pre>
<p>The ‘<code>CustomerBean</code>’ bean is just override the parent (‘<code>BaseCustomerMalaysia</code>’) <code>country</code> property, from ‘<code>Malaysia</code>’ to ‘<code>Japan</code>’.</p>
<pre class="prettyprint linenums"><code>Customer [Country=Japan, action=buy, type=1]<br />
</code></pre>
<h2>Conclusion</h2>
<p>The Spring bean configuration inheritance is very useful to avoid the repeated common value or configurations for multiple beans.</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q733lj8.html">POJ  题目分类（转载）</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqldeex9.html">stdafx&period;h的作用</a>
		</li>
						<li><a href="https://www.batexi.com/a/m962gx4q.html">npm 模块常用命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2zde3q.html">QT学习之路--菜单、工具条、状态栏</a>
		</li>
						<li><a href="https://www.batexi.com/a/49glmy7q.html">delete this及堆破坏检测方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q27pvl8.html">设计视图不能用于 x64 和 ARM 目标平台</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd03478.html">slickgrid 一个优秀的JS表格插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1ggj38.html">iMAC&mdash;&mdash;全新重装Mac系统</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m2yr1q.html">zhuan&colon; ubuntu 安装 apache2</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w6z7lq.html">PHPExcel说明</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnx50j8.html">从零开始学习jQuery &lpar;六&rpar; AJAX快餐</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm0zl49.html">（转载）在Delphi中利用MSDASC来配置数据库链接</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1e0p79.html">ggts下载地址</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zoyg4nq.html">Java和Flex积分误差（一个）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jze61l8.html">ACE&lowbar;Time&lowbar;Value</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj5e038.html">Android Studio项目构建常见问题解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpy2yzq.html">【Python3爬虫】常见反爬虫措施及解决办法（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z0nxj9.html">mybatis  insertUseGeneratedKeys 返回主键为null</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyg0mv9.html">Oracle角色，权限，表空间基础语句</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r6dn49.html">我的ehcache笔记</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9gm5wwz9.html">oracle 11g SQL Developer instead of isqlplus</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdeznej9.html">安卓自动化测试工具MonkeyRunner之使用ID进行参数化，以及List选择某项和弹出框点击确定的写法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1jnye9.html">hdu 4968 Improving the GPA &lpar;水  暴力枚举&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/93x7o309.html">用Rational Rose来建立数据库表</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1werm9.html">Windows Azure&amp;&num;174&semi; 由世纪互联运营发布MySQL Database on Azure正式商用版</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0ljr4q.html">python - wsgi协议</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydgy1gq.html">选择或者放弃MySQL的理由</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rd7nm48.html">【原创】用python实现shell的tail操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mde6gq.html">HTMLayout使用心得</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z13vwv9.html">两段简单的JS代码防止SQL注入</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
